/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ResourceDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { ResourceDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { ResourceForCreationDto } from '../../@coscine/model';
// @ts-ignore
import type { ResourceForUpdateDto } from '../../@coscine/model';
/**
 * ProjectResourceApi - axios parameter creator
 * @export
 */
export const ProjectResourceApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesOptions: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesOptions', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/resources`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Creates a new resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {ResourceForCreationDto} [resourceForCreationDto] The resource data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createResourceForProject: async (projectId: string, resourceForCreationDto?: ResourceForCreationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createResourceForProject', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/resources`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(resourceForCreationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteResourceForProject: async (projectId: string, resourceId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('deleteResourceForProject', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('deleteResourceForProject', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getResourceForProject: async (projectId: string, resourceId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getResourceForProject', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('getResourceForProject', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all resources for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getResourcesForProject: async (projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getResourcesForProject', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/resources`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource to update.
         * @param {ResourceForUpdateDto} [resourceForUpdateDto] The updated resource data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateResourceForProject: async (projectId: string, resourceId: string, resourceForUpdateDto?: ResourceForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateResourceForProject', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('updateResourceForProject', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(resourceForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectResourceApi - functional programming interface
 * @export
 */
export const ProjectResourceApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectResourceApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdResourcesOptions(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdResourcesOptions(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceApi.apiV2ProjectsProjectIdResourcesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Creates a new resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {ResourceForCreationDto} [resourceForCreationDto] The resource data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createResourceForProject(projectId: string, resourceForCreationDto?: ResourceForCreationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createResourceForProject(projectId, resourceForCreationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceApi.createResourceForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Deletes a resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteResourceForProject(projectId: string, resourceId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteResourceForProject(projectId, resourceId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceApi.deleteResourceForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getResourceForProject(projectId: string, resourceId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getResourceForProject(projectId, resourceId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceApi.getResourceForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all resources for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getResourcesForProject(projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getResourcesForProject(projectId, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceApi.getResourcesForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Updates a resource for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource to update.
         * @param {ResourceForUpdateDto} [resourceForUpdateDto] The updated resource data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateResourceForProject(projectId: string, resourceId: string, resourceForUpdateDto?: ResourceForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateResourceForProject(projectId, resourceId, resourceForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceApi.updateResourceForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectResourceApi - factory interface
 * @export
 */
export const ProjectResourceApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectResourceApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectResourceApiApiV2ProjectsProjectIdResourcesOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesOptions(requestParameters: ProjectResourceApiApiV2ProjectsProjectIdResourcesOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdResourcesOptions(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Creates a new resource for a specified project.
         * @param {ProjectResourceApiCreateResourceForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createResourceForProject(requestParameters: ProjectResourceApiCreateResourceForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<ResourceDtoResponse> {
            return localVarFp.createResourceForProject(requestParameters.projectId, requestParameters.resourceForCreationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a resource for a specified project.
         * @param {ProjectResourceApiDeleteResourceForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteResourceForProject(requestParameters: ProjectResourceApiDeleteResourceForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.deleteResourceForProject(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a resource for a specified project.
         * @param {ProjectResourceApiGetResourceForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getResourceForProject(requestParameters: ProjectResourceApiGetResourceForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<ResourceDtoResponse> {
            return localVarFp.getResourceForProject(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all resources for a specified project.
         * @param {ProjectResourceApiGetResourcesForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getResourcesForProject(requestParameters: ProjectResourceApiGetResourcesForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<ResourceDtoPagedResponse> {
            return localVarFp.getResourcesForProject(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a resource for a specified project.
         * @param {ProjectResourceApiUpdateResourceForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateResourceForProject(requestParameters: ProjectResourceApiUpdateResourceForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateResourceForProject(requestParameters.projectId, requestParameters.resourceId, requestParameters.resourceForUpdateDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdResourcesOptions operation in ProjectResourceApi.
 * @export
 * @interface ProjectResourceApiApiV2ProjectsProjectIdResourcesOptionsRequest
 */
export interface ProjectResourceApiApiV2ProjectsProjectIdResourcesOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectResourceApiApiV2ProjectsProjectIdResourcesOptions
     */
    readonly projectId: string
}

/**
 * Request parameters for createResourceForProject operation in ProjectResourceApi.
 * @export
 * @interface ProjectResourceApiCreateResourceForProjectRequest
 */
export interface ProjectResourceApiCreateResourceForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceApiCreateResourceForProject
     */
    readonly projectId: string

    /**
     * The resource data for creation.
     * @type {ResourceForCreationDto}
     * @memberof ProjectResourceApiCreateResourceForProject
     */
    readonly resourceForCreationDto?: ResourceForCreationDto
}

/**
 * Request parameters for deleteResourceForProject operation in ProjectResourceApi.
 * @export
 * @interface ProjectResourceApiDeleteResourceForProjectRequest
 */
export interface ProjectResourceApiDeleteResourceForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceApiDeleteResourceForProject
     */
    readonly projectId: string

    /**
     * The ID of the resource to delete.
     * @type {string}
     * @memberof ProjectResourceApiDeleteResourceForProject
     */
    readonly resourceId: string
}

/**
 * Request parameters for getResourceForProject operation in ProjectResourceApi.
 * @export
 * @interface ProjectResourceApiGetResourceForProjectRequest
 */
export interface ProjectResourceApiGetResourceForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceApiGetResourceForProject
     */
    readonly projectId: string

    /**
     * The ID of the resource to retrieve.
     * @type {string}
     * @memberof ProjectResourceApiGetResourceForProject
     */
    readonly resourceId: string
}

/**
 * Request parameters for getResourcesForProject operation in ProjectResourceApi.
 * @export
 * @interface ProjectResourceApiGetResourcesForProjectRequest
 */
export interface ProjectResourceApiGetResourcesForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceApiGetResourcesForProject
     */
    readonly projectId: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof ProjectResourceApiGetResourcesForProject
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof ProjectResourceApiGetResourcesForProject
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof ProjectResourceApiGetResourcesForProject
     */
    readonly orderBy?: string
}

/**
 * Request parameters for updateResourceForProject operation in ProjectResourceApi.
 * @export
 * @interface ProjectResourceApiUpdateResourceForProjectRequest
 */
export interface ProjectResourceApiUpdateResourceForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceApiUpdateResourceForProject
     */
    readonly projectId: string

    /**
     * The ID of the resource to update.
     * @type {string}
     * @memberof ProjectResourceApiUpdateResourceForProject
     */
    readonly resourceId: string

    /**
     * The updated resource data.
     * @type {ResourceForUpdateDto}
     * @memberof ProjectResourceApiUpdateResourceForProject
     */
    readonly resourceForUpdateDto?: ResourceForUpdateDto
}

/**
 * ProjectResourceApi - object-oriented interface
 * @export
 * @class ProjectResourceApi
 * @extends {BaseAPI}
 */
export class ProjectResourceApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectResourceApiApiV2ProjectsProjectIdResourcesOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceApi
     */
    public apiV2ProjectsProjectIdResourcesOptions(requestParameters: ProjectResourceApiApiV2ProjectsProjectIdResourcesOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceApiFp(this.configuration).apiV2ProjectsProjectIdResourcesOptions(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Creates a new resource for a specified project.
     * @param {ProjectResourceApiCreateResourceForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceApi
     */
    public createResourceForProject(requestParameters: ProjectResourceApiCreateResourceForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceApiFp(this.configuration).createResourceForProject(requestParameters.projectId, requestParameters.resourceForCreationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Deletes a resource for a specified project.
     * @param {ProjectResourceApiDeleteResourceForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceApi
     */
    public deleteResourceForProject(requestParameters: ProjectResourceApiDeleteResourceForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceApiFp(this.configuration).deleteResourceForProject(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a resource for a specified project.
     * @param {ProjectResourceApiGetResourceForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceApi
     */
    public getResourceForProject(requestParameters: ProjectResourceApiGetResourceForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceApiFp(this.configuration).getResourceForProject(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all resources for a specified project.
     * @param {ProjectResourceApiGetResourcesForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceApi
     */
    public getResourcesForProject(requestParameters: ProjectResourceApiGetResourcesForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceApiFp(this.configuration).getResourcesForProject(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates a resource for a specified project.
     * @param {ProjectResourceApiUpdateResourceForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceApi
     */
    public updateResourceForProject(requestParameters: ProjectResourceApiUpdateResourceForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceApiFp(this.configuration).updateResourceForProject(requestParameters.projectId, requestParameters.resourceId, requestParameters.resourceForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }
}

